<template>
  <div>
    <v-navigation-drawer
      fixed
      clipped
      app
      permanent
      width="300"
      :mini-variant="mini"
    >
      <v-toolbar>
        <v-list>
          <v-list-item>
            <v-list-item-action v-if="mini">
              <v-btn
                icon
                @click.native.stop="mini = !mini"
              >
                <v-icon>chevron_right</v-icon>
              </v-btn>
            </v-list-item-action>
            <v-list-item-content
              class="title"
            >
              {{ currentExam }}
            </v-list-item-content>
            <v-list-item-action v-if="!mini">
              <v-btn
                icon
                @click.native.stop="mini = !mini"
              >
                <v-icon>chevron_left</v-icon>
              </v-btn>
            </v-list-item-action>
          </v-list-item>
        </v-list>
      </v-toolbar>
      <slot name="sidebar-content" />
      <div class="sidebar-footer">
        <v-btn
          id="feedback-btn"
          href="https://gitlab.gwdg.de/j.michal/grady/issues"
          target="_blank"
          :block="!mini"
          :fab="mini"
          :text="mini"
          :tile="!mini"
          depressed
          :class="{ 'fab-button': mini }"
        >
          <v-icon :left="!mini">
            feedback
          </v-icon>
          <div v-show="!mini">
            Feedback
          </div>
        </v-btn>
      </div>
    </v-navigation-drawer>
    <v-app-bar
      app
      dense
      clipped-left
      fixed
      dark
      color="indigo darken-4"
      class="grady-toolbar"
    >
      <router-link to="/home">
        <v-app-bar-title>Grady</v-app-bar-title>
      </router-link>
      <v-tooltip
        v-if="multipleExams"
        bottom
      >
        <template #activator="{ on }">
          <v-btn
            id="examsButton"
            color="cyan"
            @click="changeExamSelection"
            v-on="on"
          >
            Exams
          </v-btn>
        </template>
        <span>Change selected Exam</span>
      </v-tooltip>
      <span class="pl-2 grady-speak">{{ gradySpeak }}</span>
      <v-spacer />
      <instance-actions />
      <v-divider vertical />
      <user-options />
    </v-app-bar>
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex'
import { UI } from '@/store/modules/ui'
import { mapStateToComputedGetterSetter } from '@/util/helpers'
import UserOptions from '@/components/UserOptions'
import InstanceActions from '@/components/InstanceActions'
import { Authentication } from '@/store/modules/authentication'
import { ConfigModule } from '../store/modules/config'
import ax, { fetchExamTypes } from '@/api'


export default {
  name: 'BaseLayout',
  components: { InstanceActions, UserOptions },
  data () {
    return {
      examTypes: [],
    }
  },
  computed: {
    gradySpeak () { return Authentication.gradySpeak },
    currentExam () { return ConfigModule.state.config.currentExam },
    multipleExams () {
      return this.examTypes.length > 1
    },
    isStudent () { return Authentication.isStudent },
    ...mapStateToComputedGetterSetter({
      pathPrefix: 'UI',
      items: [
        {
          name: 'mini',
          path: 'sideBarCollapsed',
          mutation: UI.SET_SIDEBAR_COLLAPSED
        }
      ]
    })
  },
  created () {
    this.loadExamTypes()
  },
  methods: {
    logFeedbackClick () {
      this.darkModeUnlocked = true
    },
    changeExamSelection () {
      this.$router.push({ name: 'exam-selection' })
    },
    async loadExamTypes () {
      try {
        const response = (await ax.get('/api/examtype/')).data
        this.examTypes = response
        console.log('loaded examtypes')
      } catch (ex) {
        console.log(ex)
      }
    }
  }
}
</script>

<style scoped>
  .sidebar-footer {
    width: 100%;
    bottom: 0px;
  }

  .grady-toolbar {
    font-weight: bold;
  }

  .title {
    color: gray;
    white-space: nowrap;
  }

  .fab-button {
    margin: 0 12px;
  }

  .fab-button-white {
    color: grey !important;
  }

  .dark-mode-switch {
    margin-left: 22px;
  }

  .v-btn {
    margin: 15px;
  }

</style>

<style>
  .grady-toolbar > div {
    padding-right: 0;
  }

  .grady-toolbar .v-btn {
    letter-spacing: initial;
    text-transform: none;
  }
</style>
